divert(-1)
changequote([, ])
# _at_MODE(SEPARATOR, ELT1, ELT2...)
# ----------------------------------
# List the elements, separating then with SEPARATOR.
# MODE can be:
#  `at'       -- the elements are enclosed in brackets.
#  `star'     -- the elements are listed as are.
#  `percent'  -- the elements are `flattened': spaces are singled out,
#                and no new line remains.
define([_at_at],
[at_ifelse([$#], [1], [],
           [$#], [2], [[[$2]]],
           [[[$2]][$1]$0([$1], at_shift(at_shift($@)))])])

define([_at_percent],
[at_ifelse([$#], [1], [],
           [$#], [2], [at_flatten([$2])],
           [at_flatten([$2])[$1]$0([$1], at_shift(at_shift($@)))])])

define([_at_star],
[at_ifelse([$#], [1], [],
           [$#], [2], [[$2]],
           [[$2][$1]$0([$1], at_shift(at_shift($@)))])])

# FLATTEN quotes its result.
# Note that the second pattern is `newline, tab or space'.  Don't lose
# the tab!
define([at_flatten],
[at_patsubst(at_patsubst(at_patsubst([[[$1]]], [\\
]),
                         [[
	 ]+], [ ]),
             [^ *\(.*\) *$], [[\1]])])

define([at_args],    [at_shift(at_shift(at_shift(at_shift(at_shift($@)))))])
define([at_at],      [_$0([$1], at_args($@))])
define([at_percent], [_$0([$1], at_args($@))])
define([at_star],    [_$0([$1], at_args($@))])

# Copy the builtins.
define([at___file__], defn([__file__]))
define([at___gnu__], defn([__gnu__]))
define([at___line__], defn([__line__]))
define([at___unix__], defn([__unix__]))
define([at_builtin], defn([builtin]))
define([at_changecom], defn([changecom]))
define([at_changequote], defn([changequote]))
define([at_changeword], defn([changeword]))
define([at_debugfile], defn([debugfile]))
define([at_debugmode], defn([debugmode]))
define([at_decr], defn([decr]))
define([at_define], defn([define]))
define([at_defn], defn([defn]))
define([at_divert], defn([divert]))
define([at_divnum], defn([divnum]))
define([at_dnl], defn([dnl]))
define([at_dumpdef], defn([dumpdef]))
define([at_errprint], defn([errprint]))
define([at_esyscmd], defn([esyscmd]))
define([at_eval], defn([eval]))
define([at_format], defn([format]))
define([at_ifdef], defn([ifdef]))
define([at_ifelse], defn([ifelse]))
define([at_include], defn([include]))
define([at_incr], defn([incr]))
define([at_index], defn([index]))
define([at_indir], defn([indir]))
define([at_len], defn([len]))
define([at_m4exit], defn([m4exit]))
define([at_m4wrap], defn([m4wrap]))
define([at_maketemp], defn([maketemp]))
define([at_patsubst], defn([patsubst]))
define([at_popdef], defn([popdef]))
define([at_pushdef], defn([pushdef]))
define([at_regexp], defn([regexp]))
define([at_shift], defn([shift]))
define([at_sinclude], defn([sinclude]))
define([at_substr], defn([substr]))
define([at_syscmd], defn([syscmd]))
define([at_sysval], defn([sysval]))
define([at_traceoff], defn([traceoff]))
define([at_traceon], defn([traceon]))
define([at_translit], defn([translit]))
define([at_undefine], defn([undefine]))
define([at_undivert], defn([undivert]))

# Disable them.
at_undefine([__file__])
at_undefine([__gnu__])
at_undefine([__line__])
at_undefine([__unix__])
at_undefine([builtin])
at_undefine([changecom])
at_undefine([changequote])
at_undefine([changeword])
at_undefine([debugfile])
at_undefine([debugmode])
at_undefine([decr])
at_undefine([define])
at_undefine([defn])
at_undefine([divert])
at_undefine([divnum])
at_undefine([dnl])
at_undefine([dumpdef])
at_undefine([errprint])
at_undefine([esyscmd])
at_undefine([eval])
at_undefine([format])
at_undefine([ifdef])
at_undefine([ifelse])
at_undefine([include])
at_undefine([incr])
at_undefine([index])
at_undefine([indir])
at_undefine([len])
at_undefine([m4exit])
at_undefine([m4wrap])
at_undefine([maketemp])
at_undefine([patsubst])
at_undefine([popdef])
at_undefine([pushdef])
at_undefine([regexp])
at_undefine([shift])
at_undefine([sinclude])
at_undefine([substr])
at_undefine([syscmd])
at_undefine([sysval])
at_undefine([traceoff])
at_undefine([traceon])
at_undefine([translit])
at_undefine([undefine])
at_undefine([undivert])

## -------------------------------------- ##
## By default neutralize all the traces.  ##
## -------------------------------------- ##

at_define([AT_AC_CONFIG_HEADERS], [at_dnl])
at_define([AT_AC_DEFINE_TRACE_LITERAL], [at_dnl])
at_define([AT_AC_LIBSOURCE], [at_dnl])
at_define([AT_AC_SUBST], [at_dnl])
at_define([AT_AH_OUTPUT], [at_dnl])
at_define([AT_include], [at_dnl])
at_define([AT_m4_include], [at_dnl])
at_define([AT_m4_pattern_allow], [at_dnl])
at_define([AT_m4_pattern_forbid], [at_dnl])

## ------------------------- ##
## Trace processing macros.  ##
## ------------------------- ##

# Trace m4_pattern_allow:allow:$1
at_define([AT_m4_pattern_allow],
[[allow:$5]])

# Trace m4_pattern_forbid:forbid:$1
at_define([AT_m4_pattern_forbid],
[[forbid:$5]])


at_divert(0)at_dnl
